﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Input;

using AForge.Video;
using AForge.Video.DirectShow;
using AForge.Imaging.Filters;
using AForge.Imaging;
using AForge;


namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
       
        private int detect = 0;
        private int x=0,y=0;
        int cursor_x; 
        int cursor_y;
        private FilterInfoCollection VideoCaptureDevices;
        private VideoCaptureDevice FinalVDOsourse;
        //
        //public delegate void NewTargetPositionHandler(IntPoint Center, Bitmap image);
        //public event NewTargetPositionHandler NewTargetPosition
        //
        public Form1()
        {
            InitializeComponent();
           
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            timer2.Start();
            label2.Text = "";
            VideoCaptureDevices = new FilterInfoCollection(FilterCategory.VideoInputDevice); //it take all capture device avilible
            foreach(FilterInfo videoCap in VideoCaptureDevices)
                comboBox1.Items.Add(videoCap.Name);
            comboBox1.SelectedIndex = 0;

        }

        private void btn_Click(object sender, EventArgs e)
        {
            FinalVDOsourse = new VideoCaptureDevice(VideoCaptureDevices[comboBox1.SelectedIndex].MonikerString);
            FinalVDOsourse.NewFrame +=new NewFrameEventHandler(FinalVDOsourse_NewFrame);
            FinalVDOsourse.Start(); //start capture from device selected
            //label2.Text = detect.ToString();
            timer1.Enabled = true;
            label2.Text = "Press Ctrl to Stop.";
            timer1.Start();
            
        }
         void FinalVDOsourse_NewFrame(object sender,NewFrameEventArgs eventArgs){
             ///source image
             Bitmap img = (Bitmap)eventArgs.Frame.Clone();
             Bitmap uimg = img;
             
             

             //// filter
             ColorFiltering filter = new ColorFiltering();
             filter.Red = new IntRange(180,255);
             filter.Green = new IntRange(0,120);
             filter.Blue = new IntRange(0,120); // select cyan
             filter.ApplyInPlace(uimg); //apply the filter
             
             
             //// gray scale filter
             uimg = Grayscale.CommonAlgorithms.BT709.Apply( uimg );
             
             //// to black white
             Threshold filter2 = new Threshold( 100 );
             filter2.ApplyInPlace(uimg);

             //// Blob couter
             BlobCounter blobCounter = new BlobCounter();
            blobCounter.FilterBlobs = true;
            blobCounter.MinWidth = 3;
            blobCounter.MinWidth = 3;
            blobCounter.MaxWidth = 400;
            blobCounter.MaxHeight = 400;

            blobCounter.ProcessImage(uimg);
            Blob[] blobs = blobCounter.GetObjectsInformation();
            //Rectangle[] blobs = blobCounter.GetObjectsRectangles();
            //////draw
            Graphics g = Graphics.FromImage(img);
            Pen penRect = new Pen(Color.Blue, 3);
            Pen penLine = new Pen(Color.Blue, 3);
            IntPoint BigestCenter = new IntPoint(0, 0);

            if (blobs.Length > 0)
            {
                //detect = blobs.Length;
                
                Blob BigestBlob = blobs[0];
                foreach (Blob blob in blobs)
                {
                    if (blob.Area > BigestBlob.Area)
                    {
                        BigestBlob = blob;
                    }

                }
                detect = BigestBlob.Area;

               BigestCenter = (IntPoint)BigestBlob.CenterOfGravity;
                g.DrawRectangle(penRect, BigestBlob.Rectangle);
                g.DrawLine(penLine, BigestBlob.CenterOfGravity.X, 0, BigestBlob.CenterOfGravity.X, img.Height);
                g.DrawLine(penLine, 0, BigestBlob.CenterOfGravity.Y, img.Width, BigestBlob.CenterOfGravity.Y);
                x = 640-(int)BigestBlob.CenterOfGravity.X;
                y = (int)BigestBlob.CenterOfGravity.Y;
            }
            
            

            //NewTargetPosition(BigestCenter, img);

            g.Dispose();
            penRect.Dispose();
            penLine.Dispose();  
             ///// end draw

              
             ////
             picbox.SizeMode = PictureBoxSizeMode.StretchImage;
             //picbox.Image = uimg;
             picbox.Image = img;
            
             //Compute_Position();
            
        }

         private void Form1_FormClosed(object sender, FormClosedEventArgs e)
         {
             if (FinalVDOsourse.IsRunning)
                 FinalVDOsourse.Stop();

         }

        
         private void timer1_Tick(object sender, EventArgs e)
         {
             if(Form.ModifierKeys == Keys.Control){
                 timer1.Stop();
                 label2.Text = "Press Alt to Start again.";
             }

             //label2.Text = detect.ToString();
              //label2.Text = cursor_x.ToString() + "," + cursor_y.ToString();
             //label2.Text = x.ToString() + "," + y.ToString();
             Compute_Position();
         }



        private void Compute_Position(){
            
            var screen = System.Windows.Forms.Screen.PrimaryScreen;
            //int h = 480/2;
            int h= 480;
            int w = 640;
            double resolution_h = 2.25*screen.Bounds.Height;
            int resolution_w = screen.Bounds.Width;
            
            //y=y-200;

            cursor_x = (int)(x*1.0 /(w*1.0) * resolution_w);
            //cursor_y = (int)(y*1.0 /(h*1.0) * resolution_h);
            cursor_y = (int)(y*1.0 /(h*1.0) * resolution_h)-800;
            
            
            
            Cursor.Position = new System.Drawing.Point(cursor_x,cursor_y);

        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            
             if(Form.ModifierKeys == Keys.Alt){
                timer1.Start();
                label2.Text = "Press Ctrl to Stop.";
             }
        }

     

        
        
    }
}
